您的位置:首页 > 其它

hdu 1708 Fibonacci String

2014-08-10 17:48 211 查看
题目链接:Fibonacci String Fibonacci String

[align=left]Problem Description[/align]
After little Jim learned Fibonacci Number in the class , he was very interest in it.

Now he is thinking about a new thing -- Fibonacci String .

He defines : str
= str[n-1] + str[n-2] ( n > 1 )

He is so crazying that if someone gives him two strings str[0] and str[1], he will calculate the str[2],str[3],str[4] , str[5]....

For example :

If str[0] = "ab"; str[1] = "bc";

he will get the result , str[2]="abbc", str[3]="bcabbc" , str[4]="abbcbcabbc" …………;

As the string is too long ,Jim can't write down all the strings in paper. So he just want to know how many times each letter appears in Kth Fibonacci String . Can you help him ?

 

[align=left]Input[/align]
The first line contains a integer N which indicates the number of test cases.

Then N cases follow.

In each case,there are two strings str[0], str[1] and a integer K (0 <= K < 50) which are separated by a blank.

The string in the input will only contains less than 30 low-case letters.

 

[align=left]Output[/align]
For each case,you should count how many times each letter appears in the Kth Fibonacci String and print out them in the format "X:N".

If you still have some questions, look the sample output carefully.

Please output a blank line after each test case.

To make the problem easier, you can assume the result will in the range of int.

 

[align=left]Sample Input[/align]

1
ab bc 3

 

[align=left]Sample Output[/align]

a:1
b:3
c:2
d:0
e:0
f:0
g:0
h:0
i:0
j:0
k:0
l:0
m:0
n:0
o:0
p:0
q:0
r:0
s:0
t:0
u:0
v:0
w:0
x:0
y:0
z:0

看到题目我想都没想,直接上模拟,交了好几发都是mle,因为串太长了,然后看题解,发现大家基本都是用dp写的....dp[i][j]表示第i个数的j的值

参考http://blog.sina.com.cn/s/blog_96e2982001014tak.html

代码:

#include<stdio.h>
#include<string.h>
const int maxn=55;
int dp[maxn][maxn];
int main()
{
//freopen("in.txt","r",stdin);
char a[50],b[50];
int k;
int t;
scanf("%d",&t);
while(t--)
{
memset(dp,0,sizeof(dp));
scanf("%s %s %d",a,b,&k);
for(int i=0;a[i];i++)
dp[0][a[i]-'a']++;
for(int i=0;b[i];i++)
dp[1][b[i]-'a']++;
for(int i=2;i<=k;i++)
for(int j=0;j<26;j++)
dp[i][j]=dp[i-1][j]+dp[i-2][j];
for(int i=0;i<26;i++)
printf("%c:%d\n",i+'a',dp[k][i]);
printf("\n");
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: